Package: cccp
Version: 0.3-1
Date: 2023-12-09
Title: Cone Constrained Convex Problems
Authors@R: c(person("Bernhard", "Pfaff", role = c("aut", "cre"), email = "bernhard@pfaffikus.de"), person("Lieven", "Vandenberghe", role = "cph", comment = "copyright holder of cvxopt"), person("Martin", "Andersen", role = "cph", comment = "copyright holder of cvxopt"), person("Joachim", "Dahl", role = "cph", comment = "copyright holder of cvxopt"))
Maintainer: Bernhard Pfaff <bernhard@pfaffikus.de>
Depends: R (>= 3.0.1), methods
Suggests: RUnit, numDeriv
LazyLoad: yes
Description: Routines for solving convex optimization problems with cone constraints by means of interior-point methods. The implemented algorithms are partially ported from CVXOPT, a Python module for convex optimization (see <https://cvxopt.org> for more information). 
Imports: Rcpp (>= 0.11.2)
LinkingTo: Rcpp, RcppArmadillo
License: GPL (>= 3)
RcppModules: CPG
NeedsCompilation: yes
Packaged: 2023-12-09 17:18:24 UTC; bp
Author: Bernhard Pfaff [aut, cre],
  Lieven Vandenberghe [cph] (copyright holder of cvxopt),
  Martin Andersen [cph] (copyright holder of cvxopt),
  Joachim Dahl [cph] (copyright holder of cvxopt)
Repository: CRAN
Date/Publication: 2023-12-09 17:50:02 UTC
Built: R 4.2.3; aarch64-apple-darwin20; 2023-12-09 19:07:21 UTC; unix
Archs: cccp.so.dSYM

[![Latest Version](https://img.shields.io/pypi/v/cccp.svg)](https://pypi.python.org/pypi/cccp) [![Python Support](https://img.shields.io/pypi/pyversions/cccp.svg)](https://pypi.python.org/pypi/cccp)

# CCCP - Semi Server Side Rendered ☭

CCCP uses [dominate](https://github.com/Knio/dominate) for generation of HTML in Python but **extends it with JavaScript snippets**

Includes:

* Custom elements that can be rendered:
    * Function declarations for simple DOM manipulation
    * Indludes of external scripts (like jquery etc.)
* Render function that can take a single or lists of *dominate HTML elements*

## HTML tag manipulation using external sourcecode from GET's

CCCP currently includes the following functions:

(They all work by fetching html from a remote endpoint and manipulating a HTML tag with a given **id**)

* **ReplaceHtml(url, id)**: Lets you replace the contents of an HTML tag
* **AppendHtml(url, id)**: Lets you append to the end of a HTML tag
* **PrependHtml(url, id)**: Lets you prepend to the beginning of a HTML tag

## Usage

Install from **PYPI** (also installs [dominate](https://github.com/Knio/dominate)):

```
$ pip install cccp
```

Import modules:
```
from dominate import tags as t
import cccp
```

Include needed definitions in HTML Head:

```
t.head(
        [
            cccp.REQUIRED,
            cccp.BOOTSTRAP,
            cccp.CreateReplaceHtmlFunc()
        ]
    )
],
t.body(
    [
        div(id="pageContent")
    ]
)
```

Use functions inside HTML to manipulate select DOM elements:

```
t.button(
    "go to blog",
    onClick=cccp.replaceHtml(
        "http://127.0.0.1:9999/page/1", "pageContent"
    ),
)
```

☝️This will replace the contents of the div `"pageContent"` with the **HTML** it `GET`'s from `"http://127.0.0.1:9999/page/1"`

see [examples/flask_example.py](https://github.com/sloev/cccp/blob/master/examples/flask_example.py) for a full demo!

## RoadMap

- [x] Simple functions for replacing/appending/prepending of DOM elements
- [x] Elements for popular js dependencies:
    - [x] **axios** used for HTTP requests (performs GET requests)
    - [x] **jquery** used for HTTP requests (does the DOM manipulation)
- [ ] Error handling in bundled javascript functions
- [ ] Simple **html forms** using **json-schema** for form validation etc
- [ ] Implement tests
- [ ] **chartjs**:
    - [ ] Element for including library
    - [ ] Functions for creating different kinds of interactive charts
- [ ] More DOM manipulation javascript functions:
    - [ ] Function for creating a [Comet](https://en.wikipedia.org/wiki/Comet_(programming)) call and replacing/prepending/appending incomming html to the DOM
    - [ ] Functions for deleting DOM elements
    - [ ] Functions for pulling regularily (timer interupt GET's)

##
## Unit testing of Geometric Program
test.GP <- function(){
    F0 <- matrix(c(3, -2, -1, 0, 1, -3), nrow = 3, ncol = 2, byrow = TRUE)
    g0 <- log(c(0.44, 10, 0.592))
    F1 <- matrix(c(-1, 3), nrow = 1, ncol = 2, byrow = TRUE)
    g1 <- log(8.62)
    ans <- gp(F0, g0, FList = list(F1), gList = list(g1))
    checkTrue(ans$status == "optimal")
    return()
}

##
## Demo for solving a SOCP with two second-order cone constraints
## (Example taken from cvxopt's userguide)
##
## Creating SOCP
## Objective
q <- c(-2, 1, 5)
## First SOC
F1 <- matrix(c(-13, 3, 5,
               -12, 12, -6),
             nrow = 2, ncol = 3, byrow = TRUE)
g1 <- c(-3, -2)
d1 <- c(-12, -6, 5)
f1 <- -12
soc1 <- socc(F = F1, g = g1, d = d1, f = f1)
## Second SOC
F2 <- matrix(c(-3, 6, 2,
               1, 9, 2,
               -1, -19, 3),
             nrow = 3, ncol = 3, byrow = TRUE)
g2 <- c(0, 3, -42)
d2 <- c(-3, 6, -10)
f2 <- 27
soc2 <- socc(F = F2, g = g2, d = d2, f = f2)
## Using main function of package
ctl <- ctrl(feastol = 1e-5)
ans <- cccp(q = q, cList = list(soc1, soc2), optctrl = ctl)
ans
getx(ans)

##
## Unit testing of Linear Program with cone constraints
test.LPCC <- function(){
    ## Creating LP
    q <- c(-6, -4, -5)
    ## NNO constraint
    G <- matrix(c(16, -14, 5,
                  7, 2, 0),
                nrow = 2, ncol = 3, byrow = TRUE)
    h <- c(-3, 5)
    nno1 <- nnoc(G = G, h = h)
    ## SOC constraint
    F1 <- matrix(c(8, 13, -12,
                   -8, 18, 6,
                   1, -3, -17),
                 nrow = 3, ncol = 3, byrow = TRUE)
    g1 <- c(-2, -14, -13)
    d1 <- c(-24, -7, 15)
    f1 <- 12
    soc1 <- socc(F = F1, g = g1, d = d1, f = f1)
    ## PSD constraint
    F1 <- matrix(c(7, -5, 1,
                   -5, 1, -7,
                   1, -7, -4),
                 nrow = 3, ncol = 3, byrow = TRUE)
    F2 <- matrix(c(3, 13, -6,
                   13, 12, -10,
                   -6, -10, -28),
                 nrow = 3, ncol = 3, byrow = TRUE)
    F3 <- matrix(c(9, 6, -6,
                   6, -7, -7,
                   -6, -7, -11),
                 nrow = 3, ncol = 3, byrow = TRUE)
    F0 <- matrix(c(68, -30, -19,
                   -30, 99, 23,
                   -19, 23, 10),
                 nrow = 3, ncol = 3, byrow = TRUE)
    psd1 <- psdc(Flist = list(F1, F2, F3), F0 = F0)
    ## Using main function of package
    ans <- cccp(q = q, cList = list(nno1, soc1, psd1))
    checkTrue(ans$status == "optimal")
    return()
}

##
## Unit testing of analytic centering problem with equality constraints
test.ACNT <- function(){
    if(requireNamespace("numDeriv", quietly = TRUE)){
        ## Creating objective, gradient and Hessian
        f0 <- function(x) -sum(log(x))
        g0 <- function(x, func = f0) numDeriv::grad(func = func, x = x)
        h0 <- function(x, func = f0) numDeriv::hessian(func = func, x = x)
        ## equality constraint
        A <- matrix(c(1, 1, 2), nrow = 1)
        b <- matrix(1, nrow = 1)
        ## initial (feasible!) point
        x0 = c(0.25, 0.25, 0.25)
        ## solving problem
        ans <- cccp(x0 = x0, f0 = f0, g0 = g0, h0 = h0, A = A, b = b)
        checkTrue(ans$status == "optimal")
    }
    return()
}

##
## Unit testing of Quadratic Program with equality and inequality constraints
test.QPIC <- function(){
    P <- 2 * matrix(c(2, .5, .5, 1), nrow = 2, ncol = 2)
    q <- c(1.0, 1.0)
    G <- -diag(2)
    h <- rep(0, 2)
    nno1 <- nnoc(G = G, h = h)
    A <- matrix(c(1.0, 1.0), nrow = 1, ncol = 2)
    b <- 1.0
    ans <- cccp(P = P, q = q, A = A, b = b, cList = list(nno1))
    checkTrue(ans$status == "optimal")
    return()
}

##
## Demo for solving an unconstrained QP
##
## Creating objects for QP
n <- 4L
M <- matrix(rnorm(n^2), nrow = n, ncol = n)
P <- crossprod(M)
q <- rnorm(n)
## Solving QP
ans <- cccp(P = P, q = q)
ans
getx(ans)

##
## Unit testing of Quadratic Program with NNO and SOC constraints
test.QPIC <- function(){
    adat <- c(0.3, -0.4, -0.2, -0.4, 1.3,
              0.6, 1.2, -1.7, 0.3, -0.3,
              -0.3, 0.0, 0.6, -1.2, -2.0)
    A <- matrix(adat, nrow = 5, ncol = 3)
    b <- c(1.5, 0.0, -1.2, -0.7, 0.0)
    P <- crossprod(A)
    q <- -crossprod(A, b)
    G = -diag(3)
    h = rep(0, 3)
    nno1 <- nnoc(G = G, h = h)
    F = diag(3)
    g = rep(0, 3)
    d = rep(0, 3)
    f = 1
    soc1 <- socc(F = F, g = g, d = d, f = f)
    ans <- cccp(P = P, q = q, cList = list(nno1, soc1))
    checkTrue(ans$status == "optimal")
    return()
}

##
## Demo for solving a constrained Least-Squares Problem:
## A quadratic program with second-order cone constraint
## (Example taken from cvxopt's userguide)
##
## Creating QP
adat <- c(0.3, -0.4, -0.2, -0.4, 1.3,
          0.6, 1.2, -1.7, 0.3, -0.3,
          -0.3, 0.0, 0.6, -1.2, -2.0)
A <- matrix(adat, nrow = 5, ncol = 3)
b <- c(1.5, 0.0, -1.2, -0.7, 0.0)
P <- crossprod(A)
q <- -crossprod(A, b)
G = -diag(3)
h = rep(0, 3)
nno1 <- nnoc(G = G, h = h)
F = diag(3)
g = rep(0, 3)
d = rep(0, 3)
f = 1
soc1 <- socc(F = F, g = g, d = d, f = f)
## Solving QP
ans <- cccp(P = P, q = q, cList = list(nno1, soc1))
ans
x <- getx(ans)
round(sqrt(sum(x^2)))

##
## Demo for solving a L1-norm approximation by means of a Linear Programs
## (Example taken from cvxopt's userguide)
##
## Creating Problem
set.seed(12345)
n <- 10
m <- 20
P <- matrix(rnorm(m * n), nrow = m, ncol = n)
q <- rnorm(m)
## Solving problem by calling wrapper-function to LP
ans <- l1norm(P = P, q = q, optctrl = ctrl())
ans
getx(ans)[1:n]

##
## Demo for solving an unconstrained QP
##
## Creating objects for QP
P <- 2 * matrix(c(2, .5, .5, 1), nrow = 2, ncol = 2)
q <- c(1.0, 1.0)
A <- matrix(c(1.0, 1.0), nrow = 1, ncol = 2)
b <- 1.0
## Solving QP
ans <- cccp(P = P, q = q, A = A, b = b)
ans
getx(ans)

##
## Demo for solving a SDP with two PSD cone constraints
## (Example taken from cvxopt's userguide)
##
## Creating SDP
## Objective
q <- c(1, -1, 1)
## First PSD cone constraint
F1 <- matrix(c(-7, -11, -11, 3), nrow = 2, ncol = 2)
F2 <- matrix(c(7, -18, -18, 8), nrow = 2, ncol = 2)
F3 <- matrix(c(-2, -8, -8, 1), nrow = 2, ncol = 2) 
F0 <- matrix(c(33, -9, -9, 26), nrow = 2, ncol = 2)
psd1 <- psdc(Flist = list(F1, F2, F3), F0 = F0)
## Second PSD cone constraint
F1 <- matrix(c(-21, -11, 0, -11, 10, 8, 0, 8, 5), nrow = 3, ncol = 3)
F2 <- matrix(c(0, 10, 16, 10, -10, -10, 16, -10, 3), nrow = 3, ncol = 3)
F3 <- matrix(c(-5, 2, -17, 2, -6, 8, -17, 8, 6), nrow = 3, ncol = 3)
F0 <- matrix(c(14, 9, 40, 9, 91, 10, 40, 10, 15), nrow = 3, ncol = 3)
psd2 <- psdc(Flist = list(F1, F2, F3), F0 = F0)
## Using main function of package
ans <- cccp(q = q, cList = list(psd1, psd2))
ans
getx(ans)

##
## Demo for geometric program
## Example taken from:
## Beightler, C.S. and D.T. Phillips, Applied Geometric Programming,
## John Wiley and Sons, New York, NY, 1976.
##
## GP formulation:
## F0 = 0.44 * x_1^3 * x_2^-2 + 10 * x_1^-1 + 0.592 * x_1 * x_2^-3
## F1 = 8.62 * x_^1^-1 * x_2^3 <= 1.0 ; x_1, x_2 > 0
##
## Creating Problem
F0 <- matrix(c(3, -2, -1, 0, 1, -3), nrow = 3, ncol = 2, byrow = TRUE)
g0 <- log(c(0.44, 10, 0.592))
F1 <- matrix(c(-1, 3), nrow = 1, ncol = 2, byrow = TRUE)
g1 <- log(8.62)
ans <- gp(F0, g0, FList = list(F1), gList = list(g1))
ans

##
## Demo for solving a QP with equality and inequality constraints
## (Example taken from cvxopt's userguide)
##
## Creating QP
P <- 2 * matrix(c(2, .5, .5, 1), nrow = 2, ncol = 2)
q <- c(1.0, 1.0)
G <- -diag(2)
h <- rep(0, 2)
nno1 <- nnoc(G = G, h = h)
A <- matrix(c(1.0, 1.0), nrow = 1, ncol = 2)
b <- 1.0
## Solving QP
ans <- cccp(P = P, q = q, A = A, b = b, cList = list(nno1))
ans
getx(ans)

##
## Demo for solving a Linear Programs with (linear) inequality constraints
## (Example taken from cvxopt's userguide)
##
## First example
## Creating LP
q <- c(-4, -5)
G <- matrix(c(2, 1, -1, 0,
              1, 2, 0, -1),
            nrow = 4, ncol = 2)
h <- c(3, 3, 0, 0)
nno1 <- nnoc(G = G, h = h)
## Using main function of package
ans <- cccp(q = q, cList = list(nno1), optctrl = ctrl())
ans
getx(ans)
## Second example
## Creating LP
q <- c(2, 1)
## linear constraints
G <- matrix(c(-1, 1,
              -1, -1,
              0, -1,
              1, -2),
            nrow = 4, ncol = 2, byrow = TRUE)
h <- matrix(c(1, -2, 0, 4))
nno1 <- nnoc(G = G, h = h)
ans <- cccp(q = q, cList = list(nno1))
ans
getx(ans)

##
## Demo for solving a Linear Program with NNO, SOC and PSD constraints
## (Example taken from cvxopt's userguide)
##
## Creating LP
q <- c(-6, -4, -5)
## NNO constraint
G <- matrix(c(16, -14, 5,
              7, 2, 0),
            nrow = 2, ncol = 3, byrow = TRUE)
h <- c(-3, 5)
nno1 <- nnoc(G = G, h = h)
## SOC constraint
F1 <- matrix(c(8, 13, -12,
               -8, 18, 6,
               1, -3, -17),
             nrow = 3, ncol = 3, byrow = TRUE)
g1 <- c(-2, -14, -13)
d1 <- c(-24, -7, 15)
f1 <- 12
soc1 <- socc(F = F1, g = g1, d = d1, f = f1)
## PSD constraint
F1 <- matrix(c(7, -5, 1,
                -5, 1, -7,
                1, -7, -4),
              nrow = 3, ncol = 3, byrow = TRUE)
F2 <- matrix(c(3, 13, -6,
                13, 12, -10,
                -6, -10, -28),
              nrow = 3, ncol = 3, byrow = TRUE)
F3 <- matrix(c(9, 6, -6,
                6, -7, -7,
                -6, -7, -11),
              nrow = 3, ncol = 3, byrow = TRUE) 
F0 <- matrix(c(68, -30, -19,
                -30, 99, 23,
                -19, 23, 10),
              nrow = 3, ncol = 3, byrow = TRUE)
psd1 <- psdc(Flist = list(F1, F2, F3), F0 = F0)
## Using main function of package
ans <- cccp(q = q, cList = list(nno1, soc1, psd1))
ans
getx(ans)

##
## Unit testing of SOCP with two second-order cone constraints
test.SOCP <- function(){
    ## Objective
    q <- c(-2, 1, 5)
    ## First SOC
    F1 <- matrix(c(-13, 3, 5,
                   -12, 12, -6),
                 nrow = 2, ncol = 3, byrow = TRUE)
    g1 <- c(-3, -2)
    d1 <- c(-12, -6, 5)
    f1 <- -12
    soc1 <- socc(F = F1, g = g1, d = d1, f = f1)
    ## Second SOC
    F2 <- matrix(c(-3, 6, 2,
                   1, 9, 2,
                   -1, -19, 3),
                 nrow = 3, ncol = 3, byrow = TRUE)
    g2 <- c(0, 3, -42)
    d2 <- c(-3, 6, -10)
    f2 <- 27
    soc2 <- socc(F = F2, g = g2, d = d2, f = f2)
    ## Using main function of package
    ctl <- ctrl(feastol = 1e-5)
    ans <- cccp(q = q, cList = list(soc1, soc2), optctrl = ctl) ## for Windows 32-bit
    checkTrue(ans$status == "optimal")
    return()
}

##
## Demo for solving an analytic centering problem with equality constraints
## (Example taken from cvxopt's userguide)
##
if(requireNamespace("numDeriv", quietly = TRUE)){
    ## Creating objective, gradient and Hessian
    f0 <- function(x) -sum(log(x))
    g0 <- function(x, func = f0) numDeriv::grad(func = func, x = x)
    h0 <- function(x, func = f0) numDeriv::hessian(func = func, x = x)
    ## equality constraint
    A <- matrix(c(1, 1, 2), nrow = 1)
    b <- matrix(1, nrow = 1)
    ## initial (feasible!) point
    x0 = c(0.25, 0.25, 0.25)
    ## solving problem
    ans <- cccp(x0 = x0, f0 = f0, g0 = g0, h0 = h0, A = A, b = b)
    ans
    getx(ans)
}

##
## Unit testing of Linear Program with inequality constraints
test.LPIC <- function(){
    ## First example
    q <- c(-4, -5)
    G <- matrix(c(2, 1, -1, 0,
                  1, 2, 0, -1),
                nrow = 4, ncol = 2)
    h <- c(3, 3, 0, 0)
    nno1 <- nnoc(G = G, h = h)
    ans <- cccp(q = q, cList = list(nno1), optctrl = ctrl())
    checkTrue(ans$status == "optimal")
    ## Second example
    q <- c(2, 1)
    G <- matrix(c(-1, 1,
                  -1, -1,
                  0, -1,
                  1, -2),
                nrow = 4, ncol = 2, byrow = TRUE)
    h <- matrix(c(1, -2, 0, 4))
    nno1 <- nnoc(G = G, h = h)
    ans <- cccp(q = q, cList = list(nno1))
    checkTrue(ans$status == "optimal")
    return()
}

##
## Unit testing of Quadratic Program with equality constraints
test.QPEC <- function(){
    P <- 2 * matrix(c(2, .5, .5, 1), nrow = 2, ncol = 2)
    q <- c(1.0, 1.0)
    A <- matrix(c(1.0, 1.0), nrow = 1, ncol = 2)
    b <- 1.0
    ## Using main function of package
    ans <- cccp(P = P, q = q, A = A, b = b)
    checkTrue(ans$status == "optimal")
    checkEqualsNumeric(drop(getx(ans)), c(0.25, 0.75))
    checkEqualsNumeric(ans$state[1], 1.875)
    return()
}
